unit Unit6;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ComCtrls, Vcl.ExtCtrls, Vcl.StdCtrls;

type
  TForm6 = class(TForm)
    pTop: TPanel;
    pLeft: TPanel;
    pBottom: TPanel;
    pRight: TPanel;
    PageControl1: TPageControl;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Button1: TButton;
    procedure Panel6StartDock(Sender: TObject; var DragObject: TDragDockObject);
    procedure pTopDockDrop(Sender: TObject; Source: TDragDockObject; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure pLeftDockDrop(Sender: TObject; Source: TDragDockObject; X,
      Y: Integer);
    procedure pLeftDockOver(Sender: TObject; Source: TDragDockObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure pLeftUnDock(Sender: TObject; Client: TControl;
      NewTarget: TWinControl; var Allow: Boolean);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form6: TForm6;

implementation

{$R *.dfm}

uses DockingUtils, ColourForm;

procedure TForm6.Button1Click(Sender: TObject);
var
  fc : TfColourForm;
begin
  fc := TfColourForm.Create(Self);
  fc.DefaultDockLocation := PageControl1;
  fc.Show;
end;

procedure TForm6.FormCreate(Sender: TObject);
begin
  pLeft.Width := 0;
  pRight.Width := 0;
end;

procedure TForm6.Panel6StartDock(Sender: TObject;
  var DragObject: TDragDockObject);
var
  p : TPanel;
begin
  p := Sender as TPanel;
  if p.Align = alLeft then
    p.Align := alNone;
  DragObject := TTransparentDragDockObject.Create(p);
end;

procedure TForm6.pLeftDockDrop(Sender: TObject; Source: TDragDockObject; X,
  Y: Integer);
var
  p : TPanel;
begin
  p := Sender as TPanel;
  p.Width := 100;
end;

procedure TForm6.pLeftDockOver(Sender: TObject; Source: TDragDockObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
var
  p : TPanel;
  R : TRect;
begin
  p := Sender as TPanel;
  if p.Width = 0 then
  begin
    if p.Align = alLeft then
    begin
      R.TopLeft := p.ClientToScreen(Point(0,0));
      R.BottomRight := p.ClientToScreen(Point(100, p.Height));
    end else
    begin
      R.TopLeft := p.ClientToScreen(Point(-100,0));
      R.BottomRight := p.ClientToScreen(Point(0, p.Height));
    end;
    Source.DockRect := R;
  end;
end;

procedure TForm6.pLeftUnDock(Sender: TObject; Client: TControl;
  NewTarget: TWinControl; var Allow: Boolean);
var
  p : TPanel;
begin
  p := Sender as TPanel;
  if p.DockClientCount = 1 then
    p.Width := 0;
end;

procedure TForm6.pTopDockDrop(Sender: TObject; Source: TDragDockObject; X,
  Y: Integer);
begin
  (Source.Control as TPanel).Align := alLeft;
  (Source.Control as TPanel).Width := 85;
end;

end.
