﻿unit PeriodicTableForm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Grids, Vcl.StdCtrls, element,
  Vcl.ExtCtrls;

type
  TfPeriodicTable = class(TForm)
    ptGrid: TDrawGrid;
    pElementDetails: TPanel;
    lAtomicNumber: TLabel;
    lSymbol: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    lAtomicWeight: TLabel;
    lName: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ptGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure ptGridSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
  private
    elements : TElements;
    PeriodicTable : TPeriodicTable;
    procedure FillElementDetails(e : IElement);
  public
    { Public declarations }

  end;

var
  fPeriodicTable: TfPeriodicTable;

implementation

{$R *.dfm}

uses ElementRenderer;


procedure TfPeriodicTable.FillElementDetails(e: IElement);
begin
  lSymbol.Caption :=  e.Symbol;
  lName.Caption := e.Name;
  lAtomicNumber.Caption := IntToStr(e.Number);
  lAtomicWeight.Caption := FloatToStr(e.Weight);
end;

procedure TfPeriodicTable.FormCreate(Sender: TObject);
var
  Dir : string;
begin
  Dir := ExtractFilePath(Application.ExeName);

  elements := TElements.Create;
  PeriodicTable := TPeriodicTable.Create(Elements);

  FillElementDetails(elements.Element((1)));
end;

procedure TfPeriodicTable.FormDestroy(Sender: TObject);
begin
  elements.Free;
  PeriodicTable.Free;
end;

procedure TfPeriodicTable.ptGridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
  e : IElement;
begin
  e := PeriodicTable.Element(ACol+1, ARow+1);

  DrawPeriodicTableCellBackground(Assigned(e), gdSelected in State, ptGrid.Canvas, Rect);

  if e <> nil then
    DrawPeriodicTableCellContents(e, ptGrid.Canvas, Rect);
end;

procedure TfPeriodicTable.ptGridSelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
var
  e : IElement;
begin
  e := PeriodicTable.Element(ACol+1, ARow+1);
  CanSelect := e <> nil;
  if not CanSelect then
    Exit;
  FillElementDetails(e);
end;

end.
